<?php
/**
 * Dolpa Dynamic Styles
 *
 * @package Dolpa
 */

function dolpa_dynamic_css()
{

    $dolpa_default = dolpa_get_default_theme_options();
    $dolpa_category_colors = get_theme_mod('dolpa_category_colors', $dolpa_default['dolpa_category_colors']);

    $dolpa_color_schema = get_theme_mod('dolpa_color_schema', $dolpa_default['dolpa_color_schema']);

    if ($dolpa_color_schema == 'fancy') {

        $dolpa_primary_color = $dolpa_default['fancy_primary_color'];
        $dolpa_secondary_color = $dolpa_default['fancy_secondary_color'];
        $dolpa_tertiary_color = $dolpa_default['fancy_tertiary_color'];
        $dolpa_text_color = $dolpa_default['fancy_text_color'];

    } elseif ($dolpa_color_schema == 'dark') {

        $dolpa_primary_color = $dolpa_default['dark_primary_color'];
        $dolpa_secondary_color = $dolpa_default['dark_secondary_color'];
        $dolpa_tertiary_color = $dolpa_default['dark_tertiary_color'];
        $dolpa_text_color = $dolpa_default['dark_text_color'];

    } elseif ($dolpa_color_schema == 'shady') {

        $dolpa_primary_color = $dolpa_default['shady_primary_color'];
        $dolpa_secondary_color = $dolpa_default['shady_secondary_color'];
        $dolpa_tertiary_color = $dolpa_default['shady_tertiary_color'];
        $dolpa_text_color = $dolpa_default['shady_text_color'];

    } else {

        $dolpa_primary_color = $dolpa_default['default_primary_color'];
        $dolpa_secondary_color = $dolpa_default['default_secondary_color'];
        $dolpa_tertiary_color = $dolpa_default['default_tertiary_color'];
        $dolpa_text_color = $dolpa_default['default_text_color'];

    }

    $background_color = '#' . get_theme_mod('background_color', 'f7f8f9');

    echo "<style type='text/css' media='all'>"; ?>

    <?php

    if ($dolpa_category_colors) {
        $dolpa_category_colors = json_decode($dolpa_category_colors);
        foreach ($dolpa_category_colors as $dolpa_category_color) {
            if (isset($dolpa_category_color->category) && $dolpa_category_color->category && isset($dolpa_category_color->category_color) && $dolpa_category_color->category_color) { ?>

                .dolpa-cat-color-<?php echo esc_attr($dolpa_category_color->category); ?>{
                background-color: <?php echo esc_attr($dolpa_category_color->category_color); ?> !important;
                }
                .dolpa-cat-color-<?php echo esc_attr($dolpa_category_color->category); ?>:after{
                border-left-color: <?php echo esc_attr($dolpa_category_color->category_color); ?> !important;
                }
                <?php
            }
        }
    }
    ?>
    .entry-meta .cat-links > a {
    background: <?php echo esc_attr($dolpa_primary_color); ?>;
    }

    button,
    .button,
    .wp-block-button__link,
    .wp-block-file .wp-block-file__button,
    input[type="button"],
    input[type="reset"],
    input[type="submit"],
    .category-widget-header .post-count,
    .article-image .trend-item{
    background: <?php echo esc_attr($dolpa_secondary_color); ?>;
    }

    .woocommerce #respond input#submit,
    .woocommerce a.button,
    .woocommerce button.button,
    .woocommerce input.button,
    .woocommerce #respond input#submit.alt,
    .woocommerce a.button.alt,
    .woocommerce button.button.alt,
    .woocommerce input.button.alt,
    .woocommerce #respond input#submit:hover,
    .woocommerce a.button:hover,
    .woocommerce button.button:hover,
    .woocommerce input.button:hover,
    .woocommerce #respond input#submit.alt:hover,
    .woocommerce a.button.alt:hover,
    .woocommerce button.button.alt:hover,
    .woocommerce input.button.alt:hover,
    .woocommerce #respond input#submit:focus,
    .woocommerce a.button:focus,
    .woocommerce button.button:focus,
    .woocommerce input.button:focus,
    .woocommerce #respond input#submit.alt:focus,
    .woocommerce a.button.alt:focus,
    .woocommerce button.button.alt:focus,
    .woocommerce input.button.alt:focus,
    .woocommerce span.onsale{
    background: <?php echo esc_attr($dolpa_secondary_color); ?>;
    }

    .woocommerce span.onsale:after{
    border-left-color: <?php echo esc_attr($dolpa_secondary_color); ?>;
    }

    .woocommerce span.onsale:before{
    border-left-color: <?php echo esc_attr($dolpa_secondary_color); ?>;
    }

    .offcanvas-main-navigation a,
    .post-content-wrap .post-content blockquote,
    .wp-block-quote,
    .site-content .booster-reactions-block,
    .site-content .booster-ratings-block,
    .booster-block .be-author-details .be-author-wrapper,
    .search-form-default .search-field-default,
    .related-post-item,
    .single .singular-main-block .content-area .booster-read-block,
    .footer-widgetarea,
    input[type="text"],
    input[type="password"],
    input[type="email"],
    input[type="url"],
    input[type="date"],
    input[type="month"],
    input[type="time"],
    input[type="datetime"],
    input[type="datetime-local"],
    input[type="week"],
    input[type="number"],
    input[type="search"],
    input[type="tel"],
    input[type="color"],
    textarea{
    background: <?php echo esc_attr(dolpa_hex2rgb($dolpa_secondary_color, 0.035)); ?>;
    }

    @media (min-width: 992px) {
    .site-layout-default .page-wrapper .header-layout-default {
    background: <?php echo esc_attr(dolpa_hex2rgb($dolpa_secondary_color, 0.025)); ?>;
    }
    }

    input,
    textarea,
    select,
    #comments .comment-list li,
    .post-navigation,
    .widget_recent_entries ul li:not(:last-child),
    .widget_recent_comments ul li:not(:last-child),
    .widget_categories ul li:not(:last-child),
    .widget_pages ul li:not(:last-child),
    .widget_archive ul li:not(:last-child),
    .widget_meta ul li:not(:last-child),
    .header-layout-1 .header-navigation-wrapper,
    .twp-minicart-content .widget_shopping_cart p.total,
    .theme-widget-list li .article-list,
    .footer-navigation{
    border-color: <?php echo esc_attr(dolpa_hex2rgb($dolpa_secondary_color, 0.085)); ?>;
    }

    .search-form .search-submit {
    border-color: <?php echo esc_attr($dolpa_secondary_color); ?>;
    }

    .ticker-title{
    background-color: <?php echo esc_attr($dolpa_tertiary_color); ?>;
    }

    a,
    .entry-meta-item .entry-meta-icon{
    color: <?php echo esc_attr($dolpa_tertiary_color); ?>;
    }

    body,
    input,
    select,
    optgroup,
    textarea {
    color: <?php echo esc_attr($dolpa_text_color); ?>;
    }

    input::-webkit-input-placeholder {
     color: <?php echo esc_attr($dolpa_text_color); ?>;
    }

    input:-ms-input-placeholder {
     color: <?php echo esc_attr($dolpa_text_color); ?>;
    }

    input::-moz-placeholder {
     color: <?php echo esc_attr($dolpa_text_color); ?>;
    }

    #offcanvas-menu .offcanvas-wraper,
    .header-searchbar-inner,
    .site-info{
    background-color: <?php echo esc_attr($background_color); ?>;
    }

    .latest-blog-block-3 .latest-blog-wrapper .theme-article,
    .archive-layout-masonry .theme-article{
    border-color: <?php echo esc_attr($background_color); ?>;
    }

    .twp-minicart-content{
    background-color: <?php echo esc_attr($background_color); ?>;
    }

    <?php echo "</style>";
}

add_action('wp_head', 'dolpa_dynamic_css', 100);

/**
 * Sanitizing Hex color function.
 */
function dolpa_sanitize_hex_color($color)
{

    if ('' === $color)
        return '';
    if (preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $color))
        return $color;

}