<?php
/**
* Footer Settings.
*
* @package Dolpa
*/

$dolpa_default = dolpa_get_default_theme_options();


$wp_customize->add_section( 'dolpa_footer_area',
	array(
	'title'      => esc_html__( 'Footer Settings', 'dolpa' ),
	'priority'   => 200,
	'capability' => 'edit_theme_options',
	'panel'      => 'theme_option_panel',
	)
);


$wp_customize->add_setting( 'dolpa_footer_columns',
	array(
	'default'           => $dolpa_default['dolpa_footer_columns'],
	'capability'        => 'edit_theme_options',
	'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control( 'dolpa_footer_columns',
	array(
	'label'       => esc_html__( 'Top Footer Column Layout', 'dolpa' ),
	'section'     => 'dolpa_footer_area',
	'type'        => 'select',
	'choices'               => array(
		'1' => esc_html__( 'One Column', 'dolpa' ),
		'2' => esc_html__( 'Two Column', 'dolpa' ),
		'3' => esc_html__( 'Three Column', 'dolpa' ),
	    ),
	)
);

$wp_customize->add_setting( 'dolpa_copyright_text',
	array(
	'default'           => $dolpa_default['dolpa_copyright_text'],
	'capability'        => 'edit_theme_options',
	'sanitize_callback' => 'sanitize_text_field',
	)
);
$wp_customize->add_control( 'dolpa_copyright_text',
	array(
	'label'    => esc_html__( 'Footer Copyright Text', 'dolpa' ),
	'section'  => 'dolpa_footer_area',
	'type'     => 'text',
	)
);
