<?php
/**
* Custom Functions.
*
* @package Dolpa
*/

if( !function_exists( 'dolpa_sanitize_sidebar_option' ) ) :

    // Sidebar Option Sanitize.
    function dolpa_sanitize_sidebar_option( $dolpa_input ){

        $dolpa_metabox_options = array( 'global-sidebar','left-sidebar','right-sidebar','no-sidebar' );
        if( in_array( $dolpa_input,$dolpa_metabox_options ) ){

            return $dolpa_input;

        }

        return;

    }

endif;

if( !function_exists( 'dolpa_sanitize_single_pagination_layout' ) ) :

    // Sidebar Option Sanitize.
    function dolpa_sanitize_single_pagination_layout( $dolpa_input ){

        $dolpa_single_pagination = array( 'no-navigation','normal-navigation','ajax-next-post-load' );
        if( in_array( $dolpa_input,$dolpa_single_pagination ) ){

            return $dolpa_input;

        }

        return;

    }

endif;

if( !function_exists( 'dolpa_sanitize_archive_layout' ) ) :

    // Sidebar Option Sanitize.
    function dolpa_sanitize_archive_layout( $dolpa_input ){

        $dolpa_archive_option = array( 'default','lateral','metro','masonry' );
        if( in_array( $dolpa_input,$dolpa_archive_option ) ){

            return $dolpa_input;

        }

        return;

    }

endif;

if( !function_exists( 'dolpa_sanitize_header_layout' ) ) :

    // Sidebar Option Sanitize.
    function dolpa_sanitize_header_layout( $dolpa_input ){

        $dolpa_header_options = array( 'layout-default','layout-1','layout-2','layout-3' );
        if( in_array( $dolpa_input,$dolpa_header_options ) ){

            return $dolpa_input;

        }

        return;

    }

endif;

if( !function_exists( 'dolpa_sanitize_single_post_layout' ) ) :

    // Single Layout Option Sanitize.
    function dolpa_sanitize_single_post_layout( $dolpa_input ){

        $dolpa_single_layout = array( 'layout-1','layout-2' );
        if( in_array( $dolpa_input,$dolpa_single_layout ) ){

            return $dolpa_input;

        }

        return;

    }

endif;

if ( ! function_exists( 'dolpa_sanitize_checkbox' ) ) :

	/**
	 * Sanitize checkbox.
	 */
	function dolpa_sanitize_checkbox( $dolpa_checked ) {

		return ( ( isset( $dolpa_checked ) && true === $dolpa_checked ) ? true : false );

	}

endif;


if ( ! function_exists( 'dolpa_sanitize_select' ) ) :

    /**
     * Sanitize select.
     */
    function dolpa_sanitize_select( $dolpa_input, $dolpa_setting ) {

        // Ensure input is a slug.
        $dolpa_input = sanitize_text_field( $dolpa_input );

        // Get list of choices from the control associated with the setting.
        $choices = $dolpa_setting->manager->get_control( $dolpa_setting->id )->choices;

        // If the input is a valid key, return it; otherwise, return the default.
        return ( array_key_exists( $dolpa_input, $choices ) ? $dolpa_input : $dolpa_setting->default );

    }

endif;


if ( ! function_exists( 'dolpa_sanitize_repeater' ) ) :
    
    /**
    * Sanitise Repeater Field
    */
    function dolpa_sanitize_repeater($input){
        $input_decoded = json_decode( $input, true );
        
        if(!empty($input_decoded)) {

            foreach ($input_decoded as $boxes => $box ){

                foreach ($box as $key => $value){

                    if( $key == 'category_color' ){

                        $input_decoded[$boxes][$key] = sanitize_hex_color( $value );

                    }else{

                        $input_decoded[$boxes][$key] = sanitize_text_field( $value );

                    }
                    
                }

            }
           
            return json_encode($input_decoded);

        }

        return $input;
    }
endif;