<?php
/**
* Sidebar Metabox.
*
* @package Dolpa
*/
 
add_action( 'add_meta_boxes', 'dolpa_metabox' );

if( ! function_exists( 'dolpa_metabox' ) ):


    function  dolpa_metabox() {
        
        add_meta_box(
            'theme-custom-metabox',
            esc_html__( 'Layout Settings', 'dolpa' ),
            'dolpa_post_metafield_callback',
            'post', 
            'normal', 
            'high'
        );
        add_meta_box(
            'theme-custom-metabox',
            esc_html__( 'Layout Settings', 'dolpa' ),
            'dolpa_post_metafield_callback',
            'page',
            'normal', 
            'high'
        ); 
    }

endif;

$dolpa_post_sidebar_fields = array(
    'global-sidebar' => array(
                    'id'        => 'post-global-sidebar',
                    'value' => 'global-sidebar',
                    'label' => esc_html__( 'Global sidebar', 'dolpa' ),
                ),
    'right-sidebar' => array(
                    'id'        => 'post-left-sidebar',
                    'value' => 'right-sidebar',
                    'label' => esc_html__( 'Right sidebar', 'dolpa' ),
                ),
    'left-sidebar' => array(
                    'id'        => 'post-right-sidebar',
                    'value'     => 'left-sidebar',
                    'label'     => esc_html__( 'Left sidebar', 'dolpa' ),
                ),
    'no-sidebar' => array(
                    'id'        => 'post-no-sidebar',
                    'value'     => 'no-sidebar',
                    'label'     => esc_html__( 'No sidebar', 'dolpa' ),
                ),
);

$dolpa_post_layout_options = array(
    'global-layout' => esc_html__( 'Global Layout', 'dolpa' ),
    'layout-1' => esc_html__( 'Simple Layout', 'dolpa' ),
    'layout-2' => esc_html__( 'Banner Layout', 'dolpa' ),
);

$dolpa_page_layout_options = array(
    'layout-1' => esc_html__( 'Simple Layout', 'dolpa' ),
    'layout-2' => esc_html__( 'Banner Layout', 'dolpa' ),
);

$dolpa_header_overlay_options = array(
    'global-layout' => esc_html__( 'Global Layout', 'dolpa' ),
    'enable-overlay' => esc_html__( 'Enable Header Overlay', 'dolpa' ),
);


/**
 * Callback function for post option.
*/
if( ! function_exists( 'dolpa_post_metafield_callback' ) ):
    
    function dolpa_post_metafield_callback() {
        global $post, $dolpa_post_sidebar_fields, $dolpa_post_layout_options, $dolpa_page_layout_options, $dolpa_header_overlay_options;
        $post_type = get_post_type($post->ID);
        wp_nonce_field( basename( __FILE__ ), 'dolpa_post_meta_nonce' ); ?>
        
        <div class="metabox-main-block">

            <div class="metabox-navbar">
                <ul>

                    <li>
                        <a id="metabox-navbar-general" class="metabox-navbar-active" href="javascript:void(0)">

                            <?php esc_html_e('General Settings', 'dolpa'); ?>

                        </a>
                    </li>

                    <li>
                        <a id="metabox-navbar-appearance" href="javascript:void(0)">

                            <?php esc_html_e('Appearance Settings', 'dolpa'); ?>

                        </a>
                    </li>

                    <?php if( $post_type == 'post' && class_exists('Booster_Extension_Class') ): ?>
                        <li>
                            <a id="twp-tab-booster" href="javascript:void(0)">

                                <?php esc_html_e('Booster Extension Settings', 'dolpa'); ?>

                            </a>
                        </li>
                    <?php endif; ?>

                </ul>
            </div>

            <div class="theme-tab-content">

                <div id="metabox-navbar-general-content" class="metabox-content-wrap metabox-content-wrap-active">

                    <div class="metabox-opt-panel">

                        <h3 class="meta-opt-title"><?php esc_html_e('Sidebar Layout','dolpa'); ?></h3>

                        <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                            <?php
                            $dolpa_post_sidebar = esc_html( get_post_meta( $post->ID, 'dolpa_post_sidebar_option', true ) ); 
                            if( $dolpa_post_sidebar == '' ){ $dolpa_post_sidebar = 'global-sidebar'; }

                            foreach ( $dolpa_post_sidebar_fields as $dolpa_post_sidebar_field) { ?>

                                <label class="description">

                                    <input type="radio" name="dolpa_post_sidebar_option" value="<?php echo esc_attr( $dolpa_post_sidebar_field['value'] ); ?>" <?php if( $dolpa_post_sidebar_field['value'] == $dolpa_post_sidebar ){ echo "checked='checked'";} if( empty( $dolpa_post_sidebar ) && $dolpa_post_sidebar_field['value']=='right-sidebar' ){ echo "checked='checked'"; } ?>/>&nbsp;<?php echo esc_html( $dolpa_post_sidebar_field['label'] ); ?>

                                </label>

                            <?php } ?>

                        </div>

                    </div>

                </div>

                <div id="metabox-navbar-appearance-content" class="metabox-content-wrap">

                    <?php if( $post_type == 'post' ): ?>

                        <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Appearance Layout','dolpa'); ?></h3>

                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                                <?php
                                $dolpa_post_layout = esc_html( get_post_meta( $post->ID, 'dolpa_post_layout', true ) ); 
                                if( $dolpa_post_layout == '' ){ $dolpa_post_layout = 'global-layout'; }

                                foreach ( $dolpa_post_layout_options as $key => $dolpa_post_layout_option) { ?>

                                    <label class="description">
                                        <input type="radio" name="dolpa_post_layout" value="<?php echo esc_attr( $key ); ?>" <?php if( $key == $dolpa_post_layout ){ echo "checked='checked'";} ?>/>&nbsp;<?php echo esc_html( $dolpa_post_layout_option ); ?>
                                    </label>

                                <?php } ?>

                            </div>

                        </div>

                        <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Header Overlay','dolpa'); ?></h3>

                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                                <?php
                                $dolpa_header_overlay = esc_html( get_post_meta( $post->ID, 'dolpa_header_overlay', true ) ); 
                                if( $dolpa_header_overlay == '' ){ $dolpa_header_overlay = 'global-layout'; }

                                foreach ( $dolpa_header_overlay_options as $key => $dolpa_header_overlay_option) { ?>

                                    <label class="description">
                                        <input type="radio" name="dolpa_header_overlay" value="<?php echo esc_attr( $key ); ?>" <?php if( $key == $dolpa_header_overlay ){ echo "checked='checked'";} ?>/>&nbsp;<?php echo esc_html( $dolpa_header_overlay_option ); ?>
                                    </label>

                                <?php } ?>

                            </div>

                        </div>
                        
                    <?php endif; ?>
                    

                    <?php if( $post_type == 'page' ): ?>

                        <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Appearance Layout','dolpa'); ?></h3>

                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                                <?php
                                $dolpa_page_layout = esc_html( get_post_meta( $post->ID, 'dolpa_page_layout', true ) ); 
                                if( $dolpa_page_layout == '' ){ $dolpa_page_layout = 'layout-1'; }

                                foreach ( $dolpa_page_layout_options as $key => $dolpa_page_layout_option) { ?>

                                    <label class="description">
                                        <input type="radio" name="dolpa_page_layout" value="<?php echo esc_attr( $key ); ?>" <?php if( $key == $dolpa_page_layout ){ echo "checked='checked'";} ?>/>&nbsp;<?php echo esc_html( $dolpa_page_layout_option ); ?>
                                    </label>

                                <?php } ?>

                            </div>

                        </div>

                        <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Header Overlay','dolpa'); ?></h3>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                <?php
                                $dolpa_ed_header_overlay = esc_attr( get_post_meta( $post->ID, 'dolpa_ed_header_overlay', true ) ); ?>

                                <input type="checkbox" id="dolpa-header-overlay" name="dolpa_ed_header_overlay" value="1" <?php if( $dolpa_ed_header_overlay ){ echo "checked='checked'";} ?>/>

                                <label for="dolpa-header-overlay"><?php esc_html_e( 'Enable Header Overlay','dolpa' ); ?></label>

                            </div>

                        </div>

                    <?php endif; ?>

                    <div class="metabox-opt-panel">

                        <h3 class="meta-opt-title"><?php esc_html_e('Feature Image Setting','dolpa'); ?></h3>

                        <div class="metabox-opt-wrap theme-checkbox-wrap">



                            <?php
                            $dolpa_ed_feature_image = esc_attr( get_post_meta( $post->ID, 'dolpa_ed_feature_image', true ) ); ?>

                            <input type="checkbox" id="dolpa-feature-image" name="dolpa_ed_feature_image" value="1" <?php if( $dolpa_ed_feature_image ){ echo "checked='checked'";} ?>/>

                            <label for="dolpa-feature-image"><?php esc_html_e( 'Disable Feature Image','dolpa' ); ?></label>

                        </div>

                    </div>

                    <?php if( $post_type == 'post' ): ?>

                         <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Navigation Setting','dolpa'); ?></h3>

                            <?php $theme_disable_ajax_load_next_post = esc_attr( get_post_meta($post->ID, 'theme_disable_ajax_load_next_post', true) ); ?>
                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                                <label><b><?php esc_html_e( 'Navigation Type','dolpa' ); ?></b></label>

                                <select name="theme_disable_ajax_load_next_post">

                                    <option <?php if( $theme_disable_ajax_load_next_post == '' || $theme_disable_ajax_load_next_post == 'global-layout' ){ echo 'selected'; } ?> value="global-layout"><?php esc_html_e('Global Layout','dolpa'); ?></option>
                                    <option <?php if( $theme_disable_ajax_load_next_post == 'no-navigation' ){ echo 'selected'; } ?> value="no-navigation"><?php esc_html_e('Disable Navigation','dolpa'); ?></option>
                                    <option <?php if( $theme_disable_ajax_load_next_post == 'normal-navigation' ){ echo 'selected'; } ?> value="normal-navigation"><?php esc_html_e('Next Previous Navigation','dolpa'); ?></option>
                                    <option <?php if( $theme_disable_ajax_load_next_post == 'ajax-next-post-load' ){ echo 'selected'; } ?> value="ajax-next-post-load"><?php esc_html_e('Ajax Load Next 3 Posts Contents','dolpa'); ?></option>

                                </select>

                            </div>
                        </div>

                    <?php endif; ?>

                </div>

                
                
                <?php if( $post_type == 'post' && class_exists('Booster_Extension_Class') ):

                    
                    $dolpa_ed_post_views = get_post_meta( $post->ID, 'dolpa_ed_post_views', true );
                    $dolpa_ed_post_read_time = get_post_meta( $post->ID, 'dolpa_ed_post_read_time', true );
                    $dolpa_ed_post_like_dislike = get_post_meta( $post->ID, 'dolpa_ed_post_like_dislike', true );
                    $dolpa_ed_post_author_box = get_post_meta( $post->ID, 'dolpa_ed_post_author_box', true );
                    $dolpa_ed_post_social_share = get_post_meta( $post->ID, 'dolpa_ed_post_social_share', true );
                    $dolpa_ed_post_reaction = get_post_meta( $post->ID, 'dolpa_ed_post_reaction', true );
                    $dolpa_ed_post_rating = get_post_meta( $post->ID, 'dolpa_ed_post_rating', true );
                    ?>

                    <div id="twp-tab-booster-content" class="metabox-content-wrap">

                        <div class="metabox-opt-panel">

                            <h3 class="meta-opt-title"><?php esc_html_e('Booster Extension Plugin Content','dolpa'); ?></h3>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-views" name="dolpa_ed_post_views" value="1" <?php if( $dolpa_ed_post_views ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-views"><?php esc_html_e( 'Disable Post Views','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-read-time" name="dolpa_ed_post_read_time" value="1" <?php if( $dolpa_ed_post_read_time ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-read-time"><?php esc_html_e( 'Disable Post Read Time','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-like-dislike" name="dolpa_ed_post_like_dislike" value="1" <?php if( $dolpa_ed_post_like_dislike ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-like-dislike"><?php esc_html_e( 'Disable Post Like Dislike','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-author-box" name="dolpa_ed_post_author_box" value="1" <?php if( $dolpa_ed_post_author_box ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-author-box"><?php esc_html_e( 'Disable Post Author Box','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-social-share" name="dolpa_ed_post_social_share" value="1" <?php if( $dolpa_ed_post_social_share ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-social-share"><?php esc_html_e( 'Disable Post Social Share','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-reaction" name="dolpa_ed_post_reaction" value="1" <?php if( $dolpa_ed_post_reaction ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-reaction"><?php esc_html_e( 'Disable Post Reaction','dolpa' ); ?></label>

                            </div>

                            <div class="metabox-opt-wrap theme-checkbox-wrap">

                                    <input type="checkbox" id="dolpa-ed-post-rating" name="dolpa_ed_post_rating" value="1" <?php if( $dolpa_ed_post_rating ){ echo "checked='checked'";} ?>/>
                                    <label for="dolpa-ed-post-rating"><?php esc_html_e( 'Disable Post Rating','dolpa' ); ?></label>

                            </div>

                        </div>

                    </div>

                <?php endif; ?>

            </div>

        </div>  
            
    <?php }
endif;

// Save metabox value.
add_action( 'save_post', 'dolpa_save_post_meta' );

if( ! function_exists( 'dolpa_save_post_meta' ) ):

    function dolpa_save_post_meta( $post_id ) {

        global $post, $dolpa_post_sidebar_fields, $dolpa_post_layout_options, $dolpa_page_layout_options, $dolpa_header_overlay_options;

        if ( !isset( $_POST[ 'dolpa_post_meta_nonce' ] ) || !wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['dolpa_post_meta_nonce'] ) ), basename( __FILE__ ) ) ){

            return;

        }

        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ){

            return;

        }
            
        if ( 'page' == $_POST['post_type'] ) {  

            if ( !current_user_can( 'edit_page', $post_id ) ){  

                return $post_id;

            }

        }elseif( !current_user_can( 'edit_post', $post_id ) ) {

            return $post_id;

        }


        foreach ( $dolpa_post_sidebar_fields as $dolpa_post_sidebar_field ) {  
            
            $old = sanitize_text_field( get_post_meta( $post_id, 'dolpa_post_sidebar_option', true ) ); 
            $new = dolpa_sanitize_sidebar_option_meta( wp_unslash( $_POST['dolpa_post_sidebar_option'] ) );

            if ( $new && $new != $old ){

                update_post_meta ( $post_id, 'dolpa_post_sidebar_option', $new );

            }elseif( '' == $new && $old ) {

                delete_post_meta( $post_id,'dolpa_post_sidebar_option', $old );

            }
            
        }

        $theme_disable_ajax_load_next_post_old = sanitize_text_field( get_post_meta( $post_id, 'theme_disable_ajax_load_next_post', true ) );
        $theme_disable_ajax_load_next_post_new = dolpa_sanitize_meta_pagination( wp_unslash( $_POST['theme_disable_ajax_load_next_post'] ) );
        if( $theme_disable_ajax_load_next_post_new && $theme_disable_ajax_load_next_post_new != $theme_disable_ajax_load_next_post_old ){

            update_post_meta ( $post_id, 'theme_disable_ajax_load_next_post', $theme_disable_ajax_load_next_post_new );

        }elseif( '' == $theme_disable_ajax_load_next_post_new && $theme_disable_ajax_load_next_post_old ) {

            delete_post_meta( $post_id,'theme_disable_ajax_load_next_post', $theme_disable_ajax_load_next_post_old );

        }

        foreach ( $dolpa_post_layout_options as $dolpa_post_layout_option ) {  
            
            $dolpa_post_layout_old = sanitize_text_field( get_post_meta( $post_id, 'dolpa_post_layout', true ) ); 
            $dolpa_post_layout_new = dolpa_sanitize_post_layout_option_meta( wp_unslash( $_POST['dolpa_post_layout'] ) );

            if ( $dolpa_post_layout_new && $dolpa_post_layout_new != $dolpa_post_layout_old ){

                update_post_meta ( $post_id, 'dolpa_post_layout', $dolpa_post_layout_new );

            }elseif( '' == $dolpa_post_layout_new && $dolpa_post_layout_old ) {

                delete_post_meta( $post_id,'dolpa_post_layout', $dolpa_post_layout_old );

            }
            
        }

        foreach ( $dolpa_page_layout_options as $dolpa_post_layout_option ) {  
            
            $dolpa_page_layout_old = sanitize_text_field( get_post_meta( $post_id, 'dolpa_page_layout', true ) ); 
            $dolpa_page_layout_new = dolpa_sanitize_post_layout_option_meta( wp_unslash( $_POST['dolpa_page_layout'] ) );

            if ( $dolpa_page_layout_new && $dolpa_page_layout_new != $dolpa_page_layout_old ){

                update_post_meta ( $post_id, 'dolpa_page_layout', $dolpa_page_layout_new );

            }elseif( '' == $dolpa_page_layout_new && $dolpa_page_layout_old ) {

                delete_post_meta( $post_id,'dolpa_page_layout', $dolpa_page_layout_old );

            }
            
        }

        $dolpa_ed_header_overlay_old = absint( get_post_meta( $post_id, 'dolpa_ed_header_overlay', true ) ); 
        $dolpa_ed_header_overlay_new = absint( wp_unslash( $_POST['dolpa_ed_header_overlay'] ) );

        if ( $dolpa_ed_header_overlay_new && $dolpa_ed_header_overlay_new != $dolpa_ed_header_overlay_old ){

            update_post_meta ( $post_id, 'dolpa_ed_header_overlay', $dolpa_ed_header_overlay_new );

        }elseif( '' == $dolpa_ed_header_overlay_new && $dolpa_ed_header_overlay_old ) {

            delete_post_meta( $post_id,'dolpa_ed_header_overlay', $dolpa_ed_header_overlay_old );

        }
        
        foreach ( $dolpa_header_overlay_options as $dolpa_header_overlay_option ) {  
            
            $dolpa_header_overlay_old = absint( get_post_meta( $post_id, 'dolpa_header_overlay', true ) ); 
            $dolpa_header_overlay_new = dolpa_sanitize_header_overlay_option_meta( wp_unslash( $_POST['dolpa_header_overlay'] ) );

            if ( $dolpa_header_overlay_new && $dolpa_header_overlay_new != $dolpa_header_overlay_old ){

                update_post_meta ( $post_id, 'dolpa_header_overlay', $dolpa_header_overlay_new );

            }elseif( '' == $dolpa_header_overlay_new && $dolpa_header_overlay_old ) {

                delete_post_meta( $post_id,'dolpa_header_overlay', $dolpa_header_overlay_old );

            }
            
        }

        $dolpa_ed_feature_image_old = absint( get_post_meta( $post_id, 'dolpa_ed_feature_image', true ) ); 
        $dolpa_ed_feature_image_new = absint( wp_unslash( $_POST['dolpa_ed_feature_image'] ) );

        if ( $dolpa_ed_feature_image_new && $dolpa_ed_feature_image_new != $dolpa_ed_feature_image_old ){

            update_post_meta ( $post_id, 'dolpa_ed_feature_image', $dolpa_ed_feature_image_new );

        }elseif( '' == $dolpa_ed_feature_image_new && $dolpa_ed_feature_image_old ) {

            delete_post_meta( $post_id,'dolpa_ed_feature_image', $dolpa_ed_feature_image_old );

        }


        

        $dolpa_ed_post_views_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_views', true ) ); 
        $dolpa_ed_post_views_new = absint( wp_unslash( $_POST['dolpa_ed_post_views'] ) );

        if ( $dolpa_ed_post_views_new && $dolpa_ed_post_views_new != $dolpa_ed_post_views_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_views', $dolpa_ed_post_views_new );

        }elseif( '' == $dolpa_ed_post_views_new && $dolpa_ed_post_views_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_views', $dolpa_ed_post_views_old );

        }

        $dolpa_ed_post_read_time_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_read_time', true ) ); 
        $dolpa_ed_post_read_time_new = absint( wp_unslash( $_POST['dolpa_ed_post_read_time'] ) );

        if ( $dolpa_ed_post_read_time_new && $dolpa_ed_post_read_time_new != $dolpa_ed_post_read_time_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_read_time', $dolpa_ed_post_read_time_new );

        }elseif( '' == $dolpa_ed_post_read_time_new && $dolpa_ed_post_read_time_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_read_time', $dolpa_ed_post_read_time_old );

        }

        $dolpa_ed_post_like_dislike_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_like_dislike', true ) ); 
        $dolpa_ed_post_like_dislike_new = absint( wp_unslash( $_POST['dolpa_ed_post_like_dislike'] ) );

        if ( $dolpa_ed_post_like_dislike_new && $dolpa_ed_post_like_dislike_new != $dolpa_ed_post_like_dislike_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_like_dislike', $dolpa_ed_post_like_dislike_new );

        }elseif( '' == $dolpa_ed_post_like_dislike_new && $dolpa_ed_post_like_dislike_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_like_dislike', $dolpa_ed_post_like_dislike_old );

        }

        $dolpa_dolpa_post_author_box_old = absint( get_post_meta( $post_id, 'dolpa_dolpa_post_author_box', true ) );
        $dolpa_dolpa_post_author_box_new = absint( wp_unslash( $_POST['dolpa_dolpa_post_author_box'] ) );

        if ( $dolpa_dolpa_post_author_box_new && $dolpa_dolpa_post_author_box_new != $dolpa_dolpa_post_author_box_old ){

            update_post_meta ( $post_id, 'dolpa_dolpa_post_author_box', $dolpa_dolpa_post_author_box_new );

        }elseif( '' == $dolpa_dolpa_post_author_box_new && $dolpa_dolpa_post_author_box_old ) {

            delete_post_meta( $post_id,'dolpa_dolpa_post_author_box', $dolpa_dolpa_post_author_box_old );

        }

        $dolpa_ed_post_social_share_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_social_share', true ) ); 
        $dolpa_ed_post_social_share_new = absint( wp_unslash( $_POST['dolpa_ed_post_social_share'] ) );

        if ( $dolpa_ed_post_social_share_new && $dolpa_ed_post_social_share_new != $dolpa_ed_post_social_share_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_social_share', $dolpa_ed_post_social_share_new );

        }elseif( '' == $dolpa_ed_post_social_share_new && $dolpa_ed_post_social_share_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_social_share', $dolpa_ed_post_social_share_old );

        }

        $dolpa_ed_post_reaction_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_reaction', true ) ); 
        $dolpa_ed_post_reaction_new = absint( wp_unslash( $_POST['dolpa_ed_post_reaction'] ) );

        if ( $dolpa_ed_post_reaction_new && $dolpa_ed_post_reaction_new != $dolpa_ed_post_reaction_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_reaction', $dolpa_ed_post_reaction_new );

        }elseif( '' == $dolpa_ed_post_reaction_new && $dolpa_ed_post_reaction_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_reaction', $dolpa_ed_post_reaction_old );

        }

        $dolpa_ed_post_author_box_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_author_box', true ) ); 
        $dolpa_ed_post_author_box_new = absint( wp_unslash( $_POST['dolpa_ed_post_author_box'] ) );

        if ( $dolpa_ed_post_author_box_new && $dolpa_ed_post_author_box_new != $dolpa_ed_post_author_box_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_author_box', $dolpa_ed_post_author_box_new );

        }elseif( '' == $dolpa_ed_post_author_box_new && $dolpa_ed_post_author_box_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_author_box', $dolpa_ed_post_author_box_old );

        }

        $dolpa_ed_post_rating_old = absint( get_post_meta( $post_id, 'dolpa_ed_post_rating', true ) ); 
        $dolpa_ed_post_rating_new = absint( wp_unslash( $_POST['dolpa_ed_post_rating'] ) );

        if ( $dolpa_ed_post_rating_new && $dolpa_ed_post_rating_new != $dolpa_ed_post_rating_old ){

            update_post_meta ( $post_id, 'dolpa_ed_post_rating', $dolpa_ed_post_rating_new );

        }elseif( '' == $dolpa_ed_post_rating_new && $dolpa_ed_post_rating_old ) {

            delete_post_meta( $post_id,'dolpa_ed_post_rating', $dolpa_ed_post_rating_old );

        }

    }

endif;   